﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace sigplusnet_csharp_color43_demo
{
    public partial class Form1 : Form
    {
        Bitmap sigBox, logo;
        Font myFont;
        int pad = 1;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if (sigPlusNET1.TabletConnectQuery() == false)
            {
                //Cannot locate pad, close
                pad = 0;
                MessageBox.Show("Cannot locate signature pad. Please make sure it is connected.\n\nThe demo will now exit.",
                    "Cannot locate signature pad",
                    System.Windows.Forms.MessageBoxButtons.OK,
                    System.Windows.Forms.MessageBoxIcon.Exclamation);
                Application.Exit();
            }
        }

        private void cmdStart_Click(object sender, EventArgs e)
        {
            myFont = new System.Drawing.Font("Verdana", 11.0F, System.Drawing.FontStyle.Regular);

            sigBox = new System.Drawing.Bitmap(Application.StartupPath + "\\sigBox.bmp");
            logo = new System.Drawing.Bitmap(Application.StartupPath + "\\Color_Topaz_Logo.bmp");

            sigPlusNET1.SetLCDCaptureMode(2);
            sigPlusNET1.SetTabletState(1);

            sigPlusNET1.LCDSetPixelDepth(8);
            sigPlusNET1.LCDSendGraphic(0, 2, 0, 0, logo);
            sigPlusNET1.LCDSetPixelDepth(0);
            sigPlusNET1.LCDWriteString(0, 2, 240, 225, myFont, "CLICK HERE TO SIGN");
            sigPlusNET1.LCDSetWindow(0, 0, 1, 1);
            sigPlusNET1.SetSigWindow(1, 0, 0, 1, 1);

            sigPlusNET1.KeyPadAddHotSpot(0, 1, 235, 220, 200, 30);
            sigPlusNET1.SetLCDCaptureMode(2);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (pad == 1)
            {
                sigPlusNET1.LCDRefresh(0, 0, 0, 480, 272);
                sigPlusNET1.LCDSetWindow(0, 0, 480, 272);
                sigPlusNET1.SetSigWindow(1, 0, 0, 480, 272);
                sigPlusNET1.KeyPadClearHotSpotList();
                sigPlusNET1.SetLCDCaptureMode(1);
                sigPlusNET1.SetTabletState(0);
            }
        }

        private void sigPlusNET1_PenDown(object sender, EventArgs e)
        {

        }

        private void sigPlusNET1_PenUp(object sender, EventArgs e)
        {
            if (sigPlusNET1.KeyPadQueryHotSpot(0) > 0)
            {
                sigPlusNET1.ClearSigWindow(1);
                sigPlusNET1.LCDRefresh(1, 235, 220, 200, 30);
                System.Threading.Thread.Sleep(1000);
                sigPlusNET1.LCDRefresh(0, 0, 0, 480, 272);
                sigPlusNET1.KeyPadClearHotSpotList();
                sigPlusNET1.LCDSetPixelDepth(8);
                sigPlusNET1.LCDSendGraphic(1, 2, 0, 184, sigBox);
                sigPlusNET1.LCDRefresh(2, 0, 184, 480, 88);
                sigPlusNET1.LCDSetWindow(0, 184, 480, 88);
                sigPlusNET1.SetSigWindow(1, 0, 184, 480, 90);
                sigPlusNET1.LCDSetPixelDepth(0);
                sigPlusNET1.LCDWriteString(0, 2, 0, 0, myFont, "Signing to this form is for example purposes only and authorizes");
                sigPlusNET1.LCDWriteString(0, 2, 0, 20, myFont, "no agreement whatsoever between signer and Topaz Systems.");
                sigPlusNET1.LCDWriteString(0, 2, 20, 150, myFont, "CLEAR");
                sigPlusNET1.LCDWriteString(0, 2, 400, 150, myFont, "OK");
                sigPlusNET1.KeyPadAddHotSpot(1, 1, 20, 150, 60, 20);
                sigPlusNET1.KeyPadAddHotSpot(2, 1, 400, 150, 25, 20);
                sigPlusNET1.SetLCDCaptureMode(2);
            }

            if (sigPlusNET1.KeyPadQueryHotSpot(1) > 0)
            {
                sigPlusNET1.ClearSigWindow(1);
                sigPlusNET1.LCDRefresh(1, 15, 150, 60, 20);
                System.Threading.Thread.Sleep(250);
                sigPlusNET1.ClearTablet();
                sigPlusNET1.LCDRefresh(2, 0, 184, 480, 88);
                sigPlusNET1.LCDRefresh(1, 15, 150, 60, 20);
            }

            if (sigPlusNET1.KeyPadQueryHotSpot(2) > 0)
            {
                sigPlusNET1.ClearSigWindow(1);
                sigPlusNET1.LCDRefresh(1, 400, 150, 20, 20);
                System.Threading.Thread.Sleep(250);
                sigPlusNET1.LCDRefresh(1, 400, 150, 20, 20);

                if (sigPlusNET1.NumberOfTabletPoints() > 0)
                {
                    string data = "Signing to this form is for example purposes only and authorizes no agreement whatsoever between signer and Topaz Systems.";

                    sigPlusNET1.SetSigCompressionMode(0);
                    sigPlusNET1.SetEncryptionMode(0);
                    sigPlusNET1.SetKeyString("0000000000000000");

                    /*the following code is used to cryptographically bind the
                    signature to some specific data, passed in
                    using the SetAutoKeyANSIData function
                    the signature will not be decrypted without this data*/
                    sigPlusNET1.AutoKeyStart();
                    sigPlusNET1.SetAutoKeyANSIData(data);
                    /*here we bind to the contents of the data variable.
                     Topaz suggests binding to the entire contents of what
                     the signer is reading and agreeing to in your application.*/

                    sigPlusNET1.AutoKeyFinish();

                    sigPlusNET1.SetSigCompressionMode(1);
                    sigPlusNET1.SetEncryptionMode(2);

                    /*********************Two ways to save the signature*
                    *************************************'
                    Method 1--storing as an ASCII string value
                    strSig = sigPlusNET1.GetSigString();
                    the strSig String variable now holds the signature as a long ASCII string.
                    this can be stored as desired, in a database, etc.

                    Method 2--storing as a SIG file on the hard drive
                    sigPlusNET1.ExportSigFile "C:\SigFile1.sig"
                    The commented-out function above will export the signature to the SIG file
                    specified (in this case C:\SigFile1.sig, saving the signature as a file on your hardrive
                    *****************************************************************************************/

                    MessageBox.Show("Signature captured...here is the SigString: " + sigPlusNET1.GetSigString());
                    sigPlusNET1.LCDWriteString(1, 0, 240, 0, myFont, " ");
                    sigPlusNET1.LCDRefresh(0, 0, 0, 480, 272);
                    sigPlusNET1.LCDSetWindow(0, 0, 480, 272);
                    sigPlusNET1.SetLCDCaptureMode(1);
                    Application.Exit();
                }
                else
                {
                    sigPlusNET1.LCDWriteString(0, 3, 130, 210, myFont, "Please sign before continuing...");
                    System.Threading.Thread.Sleep(2000);
                    sigPlusNET1.LCDRefresh(2, 125, 205, 350, 35);
                }
            }

            sigPlusNET1.ClearSigWindow(1);
        }
    }
}
